/*
 * Exemplo de uso de hierarquia: testando se um objeto  de determinada class
 * Testado por: Camila
 * 
 * Compile esta classe com as vrias opes, trocando as linhas comentadas
 * Explicaes de cada verso:
 * 1: como no foi criada qualquer instncia da classe inicial, a referncia
 *    para as variveis A e B devem ser necessariamente estticas
 *    por isso no funcionaria usar as linha 6 e 7 no lugar de 3 e 4 (teste,
 *    compile e veja a msg de erro: 
 *      "Can't make a static reference to nonstatic variable"
 * 2: resove o problema acima fazendo referncia a uma varivel da instncia
 *    de "Instancias"
 * 3: resolve o problema apontando em 1, desta vez criando duas variveis
 *    dentro do mtodo esttico "main"
 */

class Instancias {                                                           //  1
                                                                             //  2
  //static A vA = new A(); // 1                                              //  3
  //static B vB = new B(); // 1                                              //  4
                                                                             //  5
  A vA = new A(); // 2                                                       //  6
  B vB = new B(); // 2                                                       //  7
                                                                             //  8
  public static void main (String [] args) {                                 //  9
     // A vA = new A();  // 3                                                // 10
     // B vB = new B();  // 3                                                // 11
                                                                             // 12
     // use o cdigo abaixo para as verses 1 e 3                            // 13
     /* "ifs" para verses 1 e 3 * /                                         // 14
     if (vA instanceof A) System.out.println ("vA  instncia de A");        // 15
     else System.out.println ("vA no  instncia de A");                    // 16
     if (vB instanceof A) System.out.println ("vB  instncia de A");        // 17
     else System.out.println ("vB no  instncia de A");                    // 18
     if (vB instanceof B) System.out.println ("vB  instncia de B");        // 19
     else System.out.println ("vB no  instncia de B");                    // 20
     if (vA instanceof B) System.out.println ("vA  instncia de B");        // 21
     else System.out.println ("vA no  instncia de B");                    // 22
     / * */                                                                  // 23
                                                                             // 24
     // use o cdigo abaixo para as verso 2                                 // 25
     Instancias i = new Instancias();                                        // 26
                                                                             // 27
     /* "ifs" para verso 2 */                                               // 28
     if (i.vA instanceof A) System.out.println ("i.vA  instncia de A");    // 29
     else System.out.println ("i.vA no  instncia de A");                  // 30
     if (i.vB instanceof A) System.out.println ("i.vB  instncia de A");    // 31
     else System.out.println ("i.vB no  instncia de A");                  // 32
     if (i.vB instanceof B) System.out.println ("i.vB  instncia de B");    // 33
     else System.out.println ("i.vB no  instncia de B");                  // 34
     if (i.vA instanceof B) System.out.println ("i.vA  instncia de B");    // 35
     else System.out.println ("i.vA no  instncia de B");                  // 36
     /* verso 2 */                                                          // 37
     
  }
}
